/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.camel.kafkaconnector.springbatch;

import java.util.Map;
import javax.annotation.Generated;
import org.apache.camel.kafkaconnector.CamelSinkConnectorConfig;
import org.apache.kafka.common.config.ConfigDef;

@Generated("This class has been generated by camel-kafka-connector-generator-maven-plugin, remove this annotation to prevent it from being generated.")
public class CamelSpringbatchSinkConnectorConfig
        extends
            CamelSinkConnectorConfig {

    public static final String CAMEL_SINK_SPRINGBATCH_PATH_JOB_NAME_CONF = "camel.sink.path.jobName";
    public static final String CAMEL_SINK_SPRINGBATCH_PATH_JOB_NAME_DOC = "The name of the Spring Batch job located in the registry.";
    public static final String CAMEL_SINK_SPRINGBATCH_PATH_JOB_NAME_DEFAULT = null;
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_FROM_HEADER_CONF = "camel.sink.endpoint.jobFromHeader";
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_FROM_HEADER_DOC = "Explicitly defines if the jobName should be taken from the headers instead of the URI.";
    public static final Boolean CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_FROM_HEADER_DEFAULT = false;
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_LAUNCHER_CONF = "camel.sink.endpoint.jobLauncher";
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_LAUNCHER_DOC = "Explicitly specifies a JobLauncher to be used.";
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_LAUNCHER_DEFAULT = null;
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_REGISTRY_CONF = "camel.sink.endpoint.jobRegistry";
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_REGISTRY_DOC = "Explicitly specifies a JobRegistry to be used.";
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_REGISTRY_DEFAULT = null;
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_LAZY_START_PRODUCER_CONF = "camel.sink.endpoint.lazyStartProducer";
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_LAZY_START_PRODUCER_DOC = "Whether the producer should be started lazy (on the first message). By starting lazy you can use this to allow CamelContext and routes to startup in situations where a producer may otherwise fail during starting and cause the route to fail being started. By deferring this startup to be lazy then the startup failure can be handled during routing messages via Camel's routing error handlers. Beware that when the first message is processed then creating and starting the producer may take a little time and prolong the total processing time of the processing.";
    public static final Boolean CAMEL_SINK_SPRINGBATCH_ENDPOINT_LAZY_START_PRODUCER_DEFAULT = false;
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_BASIC_PROPERTY_BINDING_CONF = "camel.sink.endpoint.basicPropertyBinding";
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_BASIC_PROPERTY_BINDING_DOC = "Whether the endpoint should use basic property binding (Camel 2.x) or the newer property binding with additional capabilities";
    public static final Boolean CAMEL_SINK_SPRINGBATCH_ENDPOINT_BASIC_PROPERTY_BINDING_DEFAULT = false;
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_SYNCHRONOUS_CONF = "camel.sink.endpoint.synchronous";
    public static final String CAMEL_SINK_SPRINGBATCH_ENDPOINT_SYNCHRONOUS_DOC = "Sets whether synchronous processing should be strictly used, or Camel is allowed to use asynchronous processing (if supported).";
    public static final Boolean CAMEL_SINK_SPRINGBATCH_ENDPOINT_SYNCHRONOUS_DEFAULT = false;
    public static final String CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_LAUNCHER_CONF = "camel.component.spring-batch.jobLauncher";
    public static final String CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_LAUNCHER_DOC = "Explicitly specifies a JobLauncher to be used.";
    public static final String CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_LAUNCHER_DEFAULT = null;
    public static final String CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_REGISTRY_CONF = "camel.component.spring-batch.jobRegistry";
    public static final String CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_REGISTRY_DOC = "Explicitly specifies a JobRegistry to be used.";
    public static final String CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_REGISTRY_DEFAULT = null;
    public static final String CAMEL_SINK_SPRINGBATCH_COMPONENT_LAZY_START_PRODUCER_CONF = "camel.component.spring-batch.lazyStartProducer";
    public static final String CAMEL_SINK_SPRINGBATCH_COMPONENT_LAZY_START_PRODUCER_DOC = "Whether the producer should be started lazy (on the first message). By starting lazy you can use this to allow CamelContext and routes to startup in situations where a producer may otherwise fail during starting and cause the route to fail being started. By deferring this startup to be lazy then the startup failure can be handled during routing messages via Camel's routing error handlers. Beware that when the first message is processed then creating and starting the producer may take a little time and prolong the total processing time of the processing.";
    public static final Boolean CAMEL_SINK_SPRINGBATCH_COMPONENT_LAZY_START_PRODUCER_DEFAULT = false;
    public static final String CAMEL_SINK_SPRINGBATCH_COMPONENT_BASIC_PROPERTY_BINDING_CONF = "camel.component.spring-batch.basicPropertyBinding";
    public static final String CAMEL_SINK_SPRINGBATCH_COMPONENT_BASIC_PROPERTY_BINDING_DOC = "Whether the component should use basic property binding (Camel 2.x) or the newer property binding with additional capabilities";
    public static final Boolean CAMEL_SINK_SPRINGBATCH_COMPONENT_BASIC_PROPERTY_BINDING_DEFAULT = false;

    public CamelSpringbatchSinkConnectorConfig(
            ConfigDef config,
            Map<String, String> parsedConfig) {
        super(config, parsedConfig);
    }

    public CamelSpringbatchSinkConnectorConfig(Map<String, String> parsedConfig) {
        this(conf(), parsedConfig);
    }

    public static ConfigDef conf() {
        ConfigDef conf = new ConfigDef(CamelSinkConnectorConfig.conf());
        conf.define(CAMEL_SINK_SPRINGBATCH_PATH_JOB_NAME_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPRINGBATCH_PATH_JOB_NAME_DEFAULT, ConfigDef.Importance.HIGH, CAMEL_SINK_SPRINGBATCH_PATH_JOB_NAME_DOC);
        conf.define(CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_FROM_HEADER_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_FROM_HEADER_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_FROM_HEADER_DOC);
        conf.define(CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_LAUNCHER_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_LAUNCHER_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_LAUNCHER_DOC);
        conf.define(CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_REGISTRY_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_REGISTRY_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPRINGBATCH_ENDPOINT_JOB_REGISTRY_DOC);
        conf.define(CAMEL_SINK_SPRINGBATCH_ENDPOINT_LAZY_START_PRODUCER_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_SPRINGBATCH_ENDPOINT_LAZY_START_PRODUCER_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPRINGBATCH_ENDPOINT_LAZY_START_PRODUCER_DOC);
        conf.define(CAMEL_SINK_SPRINGBATCH_ENDPOINT_BASIC_PROPERTY_BINDING_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_SPRINGBATCH_ENDPOINT_BASIC_PROPERTY_BINDING_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPRINGBATCH_ENDPOINT_BASIC_PROPERTY_BINDING_DOC);
        conf.define(CAMEL_SINK_SPRINGBATCH_ENDPOINT_SYNCHRONOUS_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_SPRINGBATCH_ENDPOINT_SYNCHRONOUS_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPRINGBATCH_ENDPOINT_SYNCHRONOUS_DOC);
        conf.define(CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_LAUNCHER_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_LAUNCHER_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_LAUNCHER_DOC);
        conf.define(CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_REGISTRY_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_REGISTRY_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPRINGBATCH_COMPONENT_JOB_REGISTRY_DOC);
        conf.define(CAMEL_SINK_SPRINGBATCH_COMPONENT_LAZY_START_PRODUCER_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_SPRINGBATCH_COMPONENT_LAZY_START_PRODUCER_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPRINGBATCH_COMPONENT_LAZY_START_PRODUCER_DOC);
        conf.define(CAMEL_SINK_SPRINGBATCH_COMPONENT_BASIC_PROPERTY_BINDING_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_SPRINGBATCH_COMPONENT_BASIC_PROPERTY_BINDING_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPRINGBATCH_COMPONENT_BASIC_PROPERTY_BINDING_DOC);
        return conf;
    }
}